CREATE TABLE uzivatele (
  id integer(10) auto_increment,
  login varchar(40) NOT NULL,
  heslo varchar(40) NOT NULL default 'da39a3ee5e6b4b0d3255bfef95601890afd80709',
  jmeno varchar(200) NOT NULL,
  typ int(1) NOT NULL,
  UNIQUE KEY (login),
  PRIMARY KEY (id)
) type=InnoDB;

CREATE TABLE destinace (
  id integer(10) auto_increment,
  nazev varchar(100) NOT NULL,
  obrazek varchar(255),
  popis text,
  souradnice_ss double,
  souradnice_vd double,
  UNIQUE KEY (nazev),  
  PRIMARY KEY (id)  
) type=InnoDB;

CREATE TABLE sluzby (
  id integer(10) auto_increment,
  nazev varchar(100) NOT NULL,
  popis text,
  PRIMARY KEY (id)  
) type=InnoDB;

CREATE TABLE vylety (
  id integer(10) auto_increment,
  cil integer(10) NOT NULL,
  vedouci integer(10),
  odjezd datetime NOT NULL,
  navrat datetime,
  cena double NOT NULL,
  popis text,
  FOREIGN KEY (cil) REFERENCES destinace (id) ON DELETE RESTRICT,
  FOREIGN KEY (vedouci) REFERENCES uzivatele (id) ON DELETE SET NULL,
  PRIMARY KEY (id)  
) type=InnoDB;
CREATE TABLE sluzby_vyletu (
  vylet integer(10) NOT NULL,
  sluzba integer(10) NOT NULL,
  FOREIGN KEY (vylet) REFERENCES vylety (id) ON DELETE CASCADE,
  FOREIGN KEY (sluzba) REFERENCES sluzby (id) ON DELETE CASCADE,
  PRIMARY KEY (vylet,sluzba)
) type=InnoDB;

INSERT INTO uzivatele (id, login,jmeno,typ) VALUES
  (1,'admin','Administrtor',99),
  (2,'karel','Karel Vomka',1),
  (3,'lucie','Lucie Svkov',1);  

INSERT INTO destinace (id,nazev,souradnice_ss, souradnice_vd,popis,obrazek) VALUES  
(1,'Karlovy Vary', 50.228333, 12.866111, 'Karlovy Vary (nmecky Karlsbad) jsou statutrn msto v zpadnch echch a metropole Karlovarskho kraje. Msto m 53 907 obyvatel (2010) a rozlohu 59,10 km2. Je vznamnm lzeskm stediskem se znmm sklskm a potravinskm prmyslem.','http://upload.wikimedia.org/wikipedia/commons/thumb/0/0a/2007-KarlovyVary-143s.jpg/254px-2007-KarlovyVary-143s.jpg'),
(2,'Prask Hrad', 50.091056, 14.401667, 'Prask hrad je hrad (de facto hradit) v prask tvrti Hradany, tradin sdlo eskch panovnk, od roku 1918 prezidenta republiky.','http://upload.wikimedia.org/wikipedia/commons/thumb/d/d4/Hradschin_Prag.jpg/190px-Hradschin_Prag.jpg'),
(3,'Konprusk jeskyn', 49.91523, 14.06726, 'Konprusk jeskyn jsou nejdel jeskynn systm v echch. Jedn se o rozshl tpatrov jeskynn systm budovan v devonskch vpencch s vkovm rozdlem mezi jednotlivmi patry asi 70 m. Nejdve bylo objeveno v roce 1950 stedn patro jeskyn, a to zcela nhodou, pi odstelu v mstnm lomu. Konprusk jeskyn byly z vt sti zpstupnny v roce 1959.','http://upload.wikimedia.org/wikipedia/commons/thumb/e/e6/Vchod_do_Kon%C4%9Bprusk%C3%BDch_jeskyn%C3%AD.jpg/220px-Vchod_do_Kon%C4%9Bprusk%C3%BDch_jeskyn%C3%AD.jpg'),
(4,'Tel',49.184444, 15.453056, 'Historick jdro msta pat k nejcennjm mstskm pamtkovm rezervacm na Morav a v roce 1992 bylo zapsno na Seznam svtovho kulturnho ddictv UNESCO. Na pamtkov hodnot msta se podl i pedmst Star Msto, jeho historick st (okol kostela Matky Bo) je mstskou pamtkovou znou a v neposledn ad i to, e i nov vstavba 20. stolet na okrajch msta respektovala hodnotn mstsk panorma, kter nen narueno pevenou panelovou zstavbou.','http://upload.wikimedia.org/wikipedia/commons/thumb/f/fa/Tel%C4%8D.jpg/254px-Tel%C4%8D.jpg'),
(5,'Jindichv Hradec',49.15,15,'Jindichv Hradec (nm. Neuhaus) je msto lec ve vchodn sti Jihoeskho kraje, na bezch eky Nerky v okrese Jindichv Hradec. Jeho historick jdro je mstskou pamtkovou rezervac.','http://upload.wikimedia.org/wikipedia/commons/thumb/6/6c/Jindrichuv_Hradec-square2.jpg/254px-Jindrichuv_Hradec-square2.jpg'),
(6,'Hlubok',49.051111, 14.441111,'Zmek Hlubok (nmecky Frauenberg) le na nvr nad Vltavou ve mst Hlubok nad Vltavou asi 15 km severn od eskch Budjovic. Je veejnosti pstupn a pat k turisticky nejatraktivnjm pamtkm v esku. V bval zmeck jzdrn sdl Alova jihoesk galerie kter spravuje sbrku soch a obraz holandskch a flmskch mal 17. a 18. stolet.','http://upload.wikimedia.org/wikipedia/commons/thumb/2/2a/Hluboka_castle.jpg/220px-Hluboka_castle.jpg'),
(7,'Lednice',48.801389, 16.805556,'Zmek s rozlehlou zahradou pat mezi nejkrsnj komplexy v esk republice. Lednick panstv zskali roku 1249 Lichtentejnov a patilo jim bezmla 700 let.','http://upload.wikimedia.org/wikipedia/commons/thumb/5/57/Z%C3%A1mek_Lednice.jpg/220px-Z%C3%A1mek_Lednice.jpg'),
(8,'Karltejn',49.938889, 14.187778,'Karltejn, dve nazvn tak Karlv Tn[1], je stedovk hrad, nachzejc se v katastrlnm zem Budany v mstysi Karltejn v okrese Beroun, asi 30 km jihozpadn od Prahy, uprosted Chrnn krajinn oblasti esk kras.','http://upload.wikimedia.org/wikipedia/commons/thumb/c/c0/Hrad_Karl%C5%A1tejn.jpg/220px-Hrad_Karl%C5%A1tejn.jpg'),
(9,'Kokon',50.440347,14.576653,'Hrad Kokon se nachz zhruba deset kilometr severovchodn od Mlnka nad kou Povkou v Dokesk pahorkatin. Byl postaven po roce 1320, pravdpodobn praskm purkrabm Hynkem Berkou z Dub. Podle jmna hradu se cel chrnn oblast nazv Kokonskem, v podhrad je obec Kokon.','http://upload.wikimedia.org/wikipedia/commons/thumb/a/a2/Kokorin_letecky_pohled.jpg/220px-Kokorin_letecky_pohled.jpg'),
(10,'Kost',50.490278,15.135,'Kost je gotick hrad nachzejc se v eskm rji, v katastrlnm zem Podkost, sti obce Liboovice, okres Jin, jen nkolik destek metr od pomez Stedoeskho a Krlovhradeckho kraje. Postavil jej nkdy ped rokem 1349 Bene z Vartemberka. Jako jeden z mla naich hrad je umstn nikoliv na kopci, ale v dol na pskovcovm ostrohu. Dodnes je velice dobe zachovan.','http://upload.wikimedia.org/wikipedia/commons/thumb/2/2d/Kost-letecky-pohled.jpg/190px-Kost-letecky-pohled.jpg');

# popisy a souadnice pamtek byly erpny z http://cs.wikipedia.org 

INSERT INTO sluzby (id,nazev,popis) VALUES
(1,'Sndan','Po cest do destinace je zdarma podvna studen sndan.'),
(2,'Obd','V restauranm zazen destinace je smluven hromadn obd s monost vbru ze 3 pokrm.'),
(3,'Vstupn','V cen vletu je i vstupn do hlavnch st pamtky.'),
(4,'Prohldka','V cen vletu je spolen prohldka s prvodcem.'),
(5,'Cesta autobusem','Doprava je zdarma zajitna autobusem.'),
(7,'Cesta vlakem','Do destinace se dopravme vlakem projdjcm zdej malebnou krajinou (v cen)'),
(8,'Bezbarirov pstup','Autobus i destinace jsou pipraveny pro handicapovan osoby.'),
(9,'Pln penze','Na kad den vletu je pro vs pipravena sndan, obd i veer.');

INSERT INTO vylety (id,cil,vedouci,cena,odjezd,navrat,popis) VALUES
(1,6,2,800,'2011-04-25 08:00','2011-04-25 19:00','Stejn jako vdy i tentokrt vyrme do Hlubok celkem brzy, abychom si stihli vechno prohldnout.'),
(2,2,3,600,'2011-04-12 09:00','2011-04-12 16:00','Prohldka hradu vetn Chrmu Sv. Vta a obdu s prezidentem esk Republiky.'),
(3,9,3,700,'2011-04-19 09:00','2011-04-19 18:00','Ji samotn cesta Kokonkm dolm je skllm zitek a kdy se k tomu pid jet prohldka hradu, je z toho asn den strven na istm vzduchu.'),
(4,3,2,700,'2011-03-23 08:00', '2011-03-23 16:00', 'Konprusy, to jsou hnusy.');

INSERT INTO sluzby_vyletu (vylet,sluzba) VALUES
(1, 1),
(2, 1),
(4, 1),
(4, 2),
(1, 3),
(1, 4),
(2, 4),
(1, 5),
(2, 5),
(4, 5),
(2, 8),
(2, 9);