<?php
  require('road/run.php');
  $page->title = 'Přihlášení';

  // potomek třídy TPanel pro obsluhu událostí
  class TLoginPanel extends TPanel {
    // obsluha události onClick tlačítka btnOdhlasit
    public function odhlasit($sender)  {
      $this->road->security->logout();
      $this->road->queueMessage('Odhlášení bylo úspěšné',MSG_SUCCESS);
      $this->road->redirect('/index.php');
    }
    // obsluha události onClick tlačítka btnPrihlasit
    public function prihlasit($sender)  {
      // získáme aktuální databázový ovladač
      $db = $this->getDb();

      // zkontrolujeme jestli uživatel zadal vše správně
      if(!$sender->form->validate()) {
        return;
      }

      // provedeme dotaz do databáze
      $dataset = $db->query('SELECT * FROM uzivatele WHERE login = '
        .$db->quote($this->edtLogin->value)
        .' AND heslo = '.$db->quote(sha1($this->edtHeslo->value))
      );
      
      // nalezli jsme odpovídajícího uživatele?
      if($dataset->getRowCount() == 1) {
        // načteme info o uživateli do objektu
        $uzivatel = $dataset->fetchObject();
        // přihlásíme uživatele:
        //   1. parametr může být libovolná hodnota a slouží nám
        //      k identifikaci přihlášeného uživatele
        //   2. druhý parametr určuje přístupová práva daného uživatele
        //      může být buď číslo nebo seznam práv (viz. dokumentace)
        $this->road->security->login($uzivatel,(int)$uzivatel->typ);
        // oznámíme uživateli, že byl úspěšně přihlášen
        $this->road->queueMessage('Přihlášení bylo úspěšné',MSG_SUCCESS); 
        if(isset($_GET['returnTo'])) {
          // přesměrujeme na adresu předanou v GET parametru
          $this->road->redirect($_GET['returnTo']);
        } else {
          // přesměrujeme na titulní stránku
          $this->road->redirect('/index.php');
        }
      } else {
        // informujeme uživatele o neplatných údajích      
        $this->edtHeslo->setError('Neplatné přihlašovací údaje');
      }
    }
  }

  // instance potomka třídy TPanel
  $panLogin = new TLoginPanel($page,'panLogin');

  // komponenta formulář
  $frmLogin = new TForm($panLogin,'frmLogin');

  // rámeček
  $grpLogin = new TGroupBox($frmLogin,'grpLogin',array(
    'caption' => 'Přihlášení' 
  ));

  // poku jsme již přihlášení
  if($road->security->isLoggedIn()) {  
    // nabídni tlačítko pro odhlášení
    $btnOdhlasit = new TSubmitButton($grpLogin,'btnOdhlasit',array(
      'caption' => 'Odhlásit',
      'onClick' => 'odhlasit', // nasměrujeme obsluhu události onClick
    ));

  // jinak vytvoř formulář pro přihlášení
  } else {
    // pole "Uživatelské jméno:"
    $edtLogin = new TEditBox($grpLogin,'edtLogin',array(
      'caption' => 'Uživatelské jméno',
      'required' => true, // jelikož nečerpáme data z databáze
                          // musíme povinná pole nastavit ručně
      'focused' => true,  // kurzor je automaticky umístěn do tohoto pole
    ));

    // pole "Heslo:"
    $edtHeslo = new TEditBox($grpLogin,'edtHeslo',array(
      'passwordInput' => true, // budou skryty zadané znaky
      'caption' => 'Heslo',    
    ));

    // lišta tlačítek
    $tlbLogin = new TSubmitToolBar($frmLogin,'tlbLogin');

    // tlačítko  "Přihlásit:"
    $btnPrihlasit = new TSubmitButton($tlbLogin,'btnPrihlasit',array(
      'caption' => 'Přihlásit',
      'onClick' => 'prihlasit', // nasměrujeme obsluhu události onClick
      'dynamic' => false,       // proč zbytečně obnovovat stránku?
      'default' => true,        // reaguje na klávesu ENTER        
    ));
  }

  $road->run();
?>