if(window.mobileVersion == undefined) {
  var mobileVersion = false;
}
function htmlspecialchars(string) {
  return $('<div>').text(string).html();
}
function escapeValue(val) {
  return val.replace("'","\\'");  
}
function autocompletePreventSubmit(event) {
  if(event.keyCode == 13) {
    event.preventDefault();
  }
}
function closeBubbles() {
  $('.rBubblePopup').fadeOut('slow').queue(function() {
    $(this).remove();
  });
}
function jsonSuccess(data) {

  if(data.error) {
    alert(data.error.message+' >> '+data.error.file+' ('+data.error.line+')');
    return false;
  }
  if(data.javaScript) {
    $.globalEval(data.javaScript);
  }
  if(data.redirect) {
    window.location.href = data.redirect; 
//    $(location).attr("href",data.redirect);
    return false;
  }
  if(data.messages) { 
    var msgs = $('#rMainRoadMessages').stop(true,true).hide().empty();
    function checkMessages(messages, type) {
      if(messages) {
        for(var i in messages) {
          msgs.append($('<div>')
            .addClass('rMessage'+type)
            .text(messages[i])
          );          
        }
      }
    }
    checkMessages(data.messages.success, 'Success');
    checkMessages(data.messages.error, 'Error');
    checkMessages(data.messages.highlight, 'Highlight');
    handleMessages();    
  }
  return true;
}
function showMessage(msg, type) {
  if(!type) {
    type = 'Highlight';  
  }
  
  var div = $('<div>')
    .addClass('rMessage'+type);
  div.text(msg);
  div.appendTo($('#rMainRoadMessages').empty());

  handleMessages();
}

(function( $ ) {
  $.fn.notBlank = function() {
    var self = null;
    $(this).each(function() {
      self = $(this);
      if(self.is('select')) {
        if(self.val() == '') {
          self.addClass('rEmptyNotBlank');          
        }
        self.change(function() {
          if($(this).val() == '') {
            $(this).addClass('rEmptyNotBlank');
          } else {
            $(this).removeClass('rEmptyNotBlank');          
          }
        });
      } else {
        self.addClass('rNotBlank'); 
        if(!self.is(':focus') && (self.val() == '')) {
          self
            .addClass('rEmptyNotBlank')
            .val(self.attr('title'));
        }
        self.focus(function() {
          
          if($(this).hasClass('rEmptyNotBlank')) {
            $(this)
              .removeClass('rEmptyNotBlank')
              .val('');
          }
        });
        self.blur(function() {
          if($(this).val() == '') {
            $(this)
              .addClass('rEmptyNotBlank')
              .val($(this).attr('title'));
          }
        });
      }    
    });
  }
  $.fn.roadSerializeArray = function() {
    $('input.rEmptyNotBlank').val('');
    res = this.serializeArray();
    $('input.rEmptyNotBlank').each(function() {
      $(this).val($(this).attr('title'));
    });
    return res;
  }
  $.fn.expandableGroup = function(slideEffect) {
    var legend = $('>legend',this);
    var group = this;
    var txt = legend.html();
    var visibility = $('#'+group.attr('id')+'-expanded');

    if(visibility.val() == '1') {
      $('>div.rFormRow',group).show();
      legend.html(String.fromCharCode(9650)+txt);
    } else {
      $('>div.rFormRow',group).hide();    
      legend.html(String.fromCharCode(9660)+txt);
    }

    legend
     .css('cursor','pointer')
     .mouseenter(function() {
       $(this).addClass('rHover');
     })
     .mouseleave(function() {
       $(this).removeClass('rHover');
     })    
     .click(function(event) {
      event.preventDefault();
      var control = $('>div.rFormRow',group); 
      
      visibility.val(visibility.val() == '1' ? '0' : '1');

      if(slideEffect) {
        control.slideControl();
      } else {
        control.toggle();      
      }
      if(visibility.val() == '1') {
        legend.html(String.fromCharCode(9650)+txt);
      } else {
        legend.html(String.fromCharCode(9660)+txt);
      }
    });
  }
  $.fn.expandButton = function(control, slideEffect) {
    this.click(function(event) {
      event.preventDefault();
      visibility = $('#'+this.id+'-expanded').val(control.is(':visible') ? '0' : '1');
      if(slideEffect) {
        control.slideControl();
      } else {
        control.toggle();      
      }
      var txt = $(this).html();
      if(txt.substr(0,1) == String.fromCharCode(9650)) {
        txt = String.fromCharCode(9660)+txt.substr(1);
      } else {
        txt = String.fromCharCode(9650)+txt.substr(1);      
      }
      $(this).html(txt);      
    });
  }
  $.fn.slideControl = function(visibility) {
    this.each(function() {
      var self = $(this);
      var visible = self.is(':visible'); 
      box = $('#'+self.attr('id')+'-errorBox');
      self = self.add($('#'+self.attr('id')+'-label'));

      if(visible) {
        if(visibility != true) {
          box.hide();
          self.slideUp('slow');
        }        
      } else {
        if(visibility != false) {
          self.slideDown('slow').queue(function() {
            if(box.text().length > 0) {
              box.css('display','inline');
            }
            $(this).dequeue();
          });                    
        }
      }
    });    
  }
  
  $.fn.refresh = function(options) {
    if(!options) {
      options = {};
    }
    this.each(function() {
      var self = $(this);
      var id = self.attr('id');
      var extended = $('#'+id+'-extended');      
      var toHide = $(this).add(extended).add(
        $('#'+id+'-label, #'+id+'-dropDown, #'+id+'-errorBox')
      );

      if(extended.length > 0) {
        self = extended;
      }
      self.stop(true,true);
      var coord = self.offset();
//      coord.top = coord.top + $(window).scrollTop();
      
      var wait = $('<div class="rRefreshing" style="position: absolute">&nbsp;</div>')
        .offset(coord)
        .width(self.outerWidth())
        .height(self.outerHeight())
        .appendTo('body');
      var form = $(this).parents('form:first');
      options.dataType = 'html';
      options.success = function(data, textStatus) {
        var tmp = $('<span>').insertAfter(self);
        toHide.remove();
        $(data).insertAfter(tmp);
        tmp.remove();
        wait.hide().remove();
        documentReloaded();
      }
      options.error = function(XMLHttpRequest, textStatus, errorThrown) {
        wait.hide().remove();
        showMessage(textStatus,'Error');      
      }
      if(!options.data) {
        options.data = new Array(); 
      }
      if(form.length > 0) {
        if(!options.url) {
          options.url = form.attr('action');
        }
        var formData = form.roadSerializeArray();
        if(options.leaveOut) {
          $.each(options.leaveOut,function() {
            var namek = new RegExp('^'+this+'(\\[\\])?$');
            var i = 0;
            while(i < formData.length) {
              if(namek.test(formData[i].name)) {              
                formData.splice(i,1);                
              } else {
                i++;
              }
            }
          });
        }
        options.type = form.attr('method').toUpperCase();
        options.data = options.data.concat(formData); 
      } else {
        options.type = 'POST';
      }
      options.data.push({
        name: 'rAction[]',
        value: id+"-render('refresh')"
      });

      $.ajax(options);
    });
  }
  $.fn.dynamicSubmit = function(options) {
    this.click(function (event) {
      event.preventDefault();
      if(options && options.confirm && !confirm(options.confirm)) {
        return;
      }
      var form = $(this).parents('form:first');
      var fields = form.roadSerializeArray();
      fields.push({
        name: 'rOutput',
        value: 'json'
      });
      fields.push({
        name: this.name,
        value: this.value
      });
      fields.push({
        name: 'rAction[]',
        value: this.id+"-render('dynamicSubmit')"
      });
      $.fancybox.showActivity();      
      $.ajax({
        url: form.attr('action'),
        type: form.attr('method').toUpperCase(),
        dataType: 'json',
        data: fields,
        success: function(data, textStatus) {
          $.fancybox.hideActivity();
          if(jsonSuccess(data)) {
            $('.rInputErrorBox:visible',form).hide();
            $('.rInputError',form).removeClass('rInputError');            
            if(data.inputErrors) {
              for(var i in data.inputErrors) {
                var error = data.inputErrors[i];
                $('#'+error.name+'-errorBox').css('display','inline').text(error.message);
                $('#'+error.name+', input#'+error.name+'-extended, #'+error.name+'-label')
                  .addClass('rInputError');
                $('#'+error.name+'-filter, #'+error.name+'-serchbox').parents('div.rSelectBox-linker, div.rSelectBox-wrapper')
                  .addClass('rInputError');
              }
            } 
          }
        },
        error: function(XMLHttpRequest, textStatus, errorThrown) {
          $.fancybox.hideActivity();
          showMessage(textStatus,'Error');
        }        
      });   
    });
  }

  $.fn.getAsFormData = function() {
    var result = {};
    this.each(function() {
      var self = $(this);
      if(self.is('input')) {
        if(!self.is('[type=checkbox]')) {
          result[self.attr('name')] = self.val();
        }
        if(!self.is('[type=submit]')) {
          result[self.attr('name')] = self.val();
        }
      }
    });
    return result;
  }
  $.fn.popupBubble = function(options) {
    var elm = this;

    closeBubbles();
    var bubble = $('<div class="rBubblePopup" style="display: none;">').appendTo('body');
    $('<div class="rBubblePopup-caption">').appendTo(bubble).text(options.caption);
    var text = null;
    if(options.text || options.html) {
      var text = $('<div class="rBubblePopup-text">').appendTo(bubble);
      if(options.html) {
        text.html(options.html);
      } else {
        text.text(options.text);
      }
    }
    if(mobileVersion) {
      var coord = bubble.offset();
      coord.top = $(window).scrollTop()+5; 
    } else {
      var coord = elm.offset();
      coord.top = coord.top - bubble.outerHeight(true) - 2 + $(window).scrollTop();
      if(coord.top < 0) {
        coord.top = 0;
      }
      coord.left = coord.left + 2;
    }      
    bubble.offset(coord).fadeIn('slow');
    if(options.timeout) {
      bubble.delay(options.timeout).queue(function() {
        $(this)
          .fadeOut('slow')
          .dequeue();
      });
    }
  }
})( jQuery );



(function( $ ) {
  jQuery.fn.outerHtml = function(s) {
    return (s)
    ? this.before(s).remove()
    : jQuery("<p>").append(this.eq(0).clone()).html();
  }
  $.fn.showAsFancyBox = function(onClose,options) {
    this.remove().show();
    if(onClose != null) {
      onClose('haha');
    }
//    this.show();
    if(!options) {
      options = {};
    }
    $.fancybox(this,options);
//    $.fancybox($('<div>').append(this).html(),options);
  }
})( jQuery );

(function( $ ) {

	$.widget( "ui.autocompletion", {
    options:{
      list: null,
      dynamic: false,
      delay:300,
      minLength:1
    },
		_create: function() {		
		  var self = this;
		  var elm = this.element;
		  elm.bind('keypress',autocompletePreventSubmit);      
		  if(this.options.dynamic) {		  
		    this.options.source = function(request, response) {
          var form = elm.parents('form:first');
          if(form.length > 0) {
            url = form.attr('action');
            postData = form.roadSerializeArray();            
          } else {
            url = $(location).attr('href');
            postData = new Array(); 
          }
          postData = postData.concat([{
            name: "rOutput",
            value: "json"
          },{
            name: "rAction[]",
            value: elm.attr('id')+"-fetchList('" + escapeValue(request.term) + "')"
          },{
            name: "rAction[]",
            value: elm.attr('id')+"-render('autoComplete')"
          }]);

          $.post( url, postData,response, 'json');
        }         
		  } else {
		    this.options.source = this.options.list;
		  }
      elm.autocomplete(this.options);
		}
	});
})( jQuery );

(function( $ ) {
	$.widget( "ui.linker", {
    options:{
      dynamic: false,
      delay:300,
      minLength:1,
      emptyMessage: 'nothing selected'
    },
		_create: function() {		
		  var self = this;
		  var select = this.element;//.hide();
		  var radio = select.is('div');
		  var wrapper = $('<div class="rSelectBox-linker">').attr('id',select.attr('id')+'-extended').insertAfter(select);
		  wrapper.attr('style',select.attr('style'));
		  var linked = $('<div class="rSelectBox-linked">').appendTo(wrapper);
      var filterId = select.attr('id')+'-filter';
		  var filter = $('<div class="rSelectBox-filter">').appendTo(wrapper);		  
      $('#'+select.attr('id')+'-label').attr('for',filterId);      
      var empty = $('<div class="rSelectBox-empty">').appendTo(linked).text(this.options.emptyMessage);      
      function createSymbol(item) {
        empty.hide();
        linked.append(' ');
        var span = $('<div class="rSelectBox-linked-item">').hide().attr('id',select.attr('id')+'-linked-'+item.optionValue).appendTo(linked).css('display','inline');
        var remove = $('<a href="#" class="rSelectBox-linked-remove">X</a>');        
        var caption = $('<a href="#" class="rSelectBox-linked-caption">'+htmlspecialchars(item.label)+'</a>').appendTo(span).click(function(event) {
          if(mobileVersion) {
            if(!confirm(item.label+'\n'+item.title)) {
              remove.click();
            }
          } else {
            caption.popupBubble({'caption': item.label, 'text': item.title});
          }
          event.preventDefault();
        }).blur(function() {
          closeBubbles();
        });
        remove.appendTo(span).click(function(event) {
          event.preventDefault();
     			var matcher = new RegExp( $.ui.autocomplete.escapeRegex( item.optionValue ), "i" );                
          $((radio ? 'input' : 'option'),select).each(function() {
            if(this.value.match(matcher)) {
              if(radio) {
                this.checked = false;
              } else {
                this.selected = false;
              }
            }
          });
          span.fadeOut('slow').remove();
          if($('div.rSelectBox-linked-item',linked).length == 0) {
            empty.show();
          }
        });
        span.fadeIn('slow');
                
      }

      this.options.select = function( event, ui ) {
   			var matcher = new RegExp( $.ui.autocomplete.escapeRegex( ui.item.optionValue ), "i" );
        var found = null; 
        $((radio ? 'input' : 'option'),select).each(function() {
          if(this.value.match(matcher)) {
            found = $(this);
            return false;
          }
        });
        
        if(found == null) {
          found = $('<'+(radio ? 'input type="checkbox"' : 'option')+'>')
            .attr('name',select.attr('id')+'[]')
            .attr('value',ui.item.optionValue)
            .appendTo(select);
          if(!radio) {
            found.text(ui.item.label);
          }
        }
        if(radio) {        
          if(!found.is(':checked')) {
            found.attr('checked',true);
            createSymbol(ui.item);          
          }
        } else {
          if(!found.is(':selected')) {
            found.attr('selected',true);
            createSymbol(ui.item);          
          }
        }
        input.bind('keypress',autocompletePreventSubmit).val('');
        var freshClass = 'rSelectBox-linked-fresh';
        $('#'+select.attr('id')+'-linked-'+ui.item.optionValue,linked)
//          .addClass(freshClass)
          .delay('200')
          .queue(function() {
             $(this)
              .addClass(freshClass)
              .dequeue();             
          })          
          .delay('200')
          .queue(function() {            
             $(this)
              .removeClass(freshClass)
              .dequeue();
          })
          .delay('200')
          .queue(function() {
             $(this)
              .addClass(freshClass)
              .dequeue();             
          })
          .delay('200')
          .queue(function() {            
             $(this)
              .removeClass(freshClass)
              .dequeue();
          })          
          .delay('200')
          .queue(function() {
             $(this)
              .addClass(freshClass)
              .dequeue();             
          })
          .delay('200')
          .queue(function() {            
             $(this)
              .removeClass(freshClass)
              .dequeue();
          })
          ;
        event.preventDefault();          
      }

      var list = new Array();
      if(radio) {
        $('input',select).each(function () {
          var opt = {
            optionValue: this.value,
            label: $(this).next('label').text(),
            value: $(this).next('label').text(),
            title: $(this).attr('title'),
            cssClass: $(this).attr('class'),
            cssStyle: $(this).attr('style'),
            id: $(this).attr('id')
          }
          list.push(opt);
          if(this.checked) {
            createSymbol(opt);
          }
        });
      } else {
        $('option',select).each(function () {
          var opt = {
            optionValue: this.value,
            label: $(this).text(),
            value: $(this).text(),
            title: $(this).attr('title'),
            cssClass: $(this).attr('class'),
            cssStyle: $(this).attr('style'),
            id: $(this).attr('id')
          }
          list.push(opt);
          if(this.selected) {
            createSymbol(opt);
          }
        });
      }
      
		  if(this.options.dynamic) {
/*        var form = $(this).parents('form:first');		    
		      if(select.form) {
      if(!options.data) {
        options.data = new Array(); 
      }
      if(form.length > 0) {
        if(!options.url) {
          options.url = form.attr('action');
        }
        var formData = form.roadSerializeArray();
		      }*/
		    this.options.source = function(request, response) {
          var form = select.parents('form:first');
          if(form.length > 0) {
            url = form.attr('action');
            postData = form.roadSerializeArray();            
          } else {
            url = $(location).attr('href');
            postData = new Array(); 
          }
          postData = postData.concat([{
            name: "rOutput",
            value: "json"
          },{
            name: "rAction[]",
            value: select.attr('id')+"-filter('" + escapeValue(request.term) + "')"
          },{
            name: "rAction[]",
            value: select.attr('id')+"-render('options')"
          }]);

          $.post( url, postData, function(data) {
            if(jsonSuccess(data)) {				    
  				    var i;
              for (i=0;i<data.length;i++) {
                data[i].optionValue = data[i].value.toString();
  				      data[i].value = data[i].label;
  				    }
              response(data);
            }
          }, 'json');
        }         
		  } else {
		    this.options.source = list;
		  }

      var input = $('<input class="rEditBox rSelectBox-filter">')
		    .attr('id',filterId)

        .appendTo(filter)
        .autocomplete(this.options);
			if(!mobileVersion) {
        if(select.is(':visible')) {
          wrapper.width(select.outerWidth(false));
          input.outerWidth(select.outerWidth());
        } else {
          wrapper.width(select.width());
          input.outerWidth(select.width());
        }
      }
      select.hide();
		}
	});
})( jQuery );

(function( $ ) {
	$.widget( "ui.searchbox", {
	  options: {
	    multiselect: false,
	    filter: '',
	    unfilter: '',	    
	    allTitle: '',
	    noneTitle: '',
	    inverseTitle: '',
	    all: null,
	    none: null,
	    inverse: null
    }, 
		_create: function() {
		  var self = this;
		  var select = this.element;/*.bind('blur',function(event) {
          select.removeClass('rFocused');
      });*/
		  var radio = select.is('div');      		  
		  var wrapper = select.wrap('<div class="rSelectBox-wrapper">').parent().attr('id',select.attr('id')+'-extended');
      var toolbar = $('<div class="rSelectBox-toolbar">')
        .insertBefore(select);

      if(this.options.multiselect) {
        var buttons = $('<div class="rSelectBox-buttons">');
        buttons
          .css('display','inline')
          .appendTo(toolbar);                
//        buttons.append('<span>'+htmlspecialchars(this.options.select)+'</span>');
        if(this.options.all) {
//          buttons.append(' ');         
          $('<a href="#">'+htmlspecialchars(this.options.all)+'</a>').appendTo(buttons)
          .addClass('rButton')
          .click(function(event) {
            event.preventDefault();
            if(radio) {
              $('div:visible input',select).attr('checked',true);
            } else {
              $('option:visible',select).attr('selected',true);
            }
          })
          .attr('title',this.options.allTitle);
        }
        if(this.options.none) { 
          $('<a href="#">'+htmlspecialchars(this.options.none)+'</a>')
          .appendTo(buttons)          
          .addClass('rButton')
          .attr('title',this.options.noneTitle)
          .click(function(event) {
            event.preventDefault();
            if(radio) {
              $('div:visible input',select).attr('checked',false);
            } else {
              $('option:visible',select).attr('selected',false);
            }
          });                    
        }
        if(this.options.inverse) { 

          $('<a href="#">'+htmlspecialchars(this.options.inverse)+'</a>').appendTo(buttons)
          .attr('title',this.options.inverseTitle)
          .addClass('rButton')
          .click(function(event) {
            event.preventDefault();
            if(radio) {
              $('div:visible input',select).each(function() {
                this.checked = !this.checked; 
              });
            } else {
              $('option:visible',select).each(function() {
                this.selected = !this.selected; 
              });
            }
          });                    
        }
        buttons        
//          .append(' ')
//          .append('<span>'+htmlspecialchars(this.options.visible)+'</span>')
          .appendTo(toolbar);
      }
      var filterbar = $('<div class="rSelectBox-filter">')
        .css('display','inline')
        .appendTo(toolbar);
      if(this.options.multiselect) {
        $('legend',select)
          .addClass('rSelectGroup')
          .css('cursor','pointer')
          .mouseenter(function() {
            $(this).addClass('rHover');
          })
          .mouseleave(function() {
            $(this).removeClass('rHover');
          })
          .click(function() {
            var alreadyClicked = ($(this).data('rAlreadyClicked') ? true : false);
            $('input:visible',$(this).parent()).attr('checked',!alreadyClicked);
            $(this).data('rAlreadyClicked',!alreadyClicked);
          });
      }
      $('input',select).each(function() {
        $(this).bind('focus',function(event) {
          $(this).parent().addClass('rFocused');
          select.addClass('rFocused');
        }).bind('blur',function(event) {        
          $(this).parent().removeClass('rFocused');
          select.removeClass('rFocused');
        }).bind('keydown',function(event) {
          var sibling = null;
          if((event.which == 40) || (event.which == 38)) {
            var parent = $(this).parent();
            if(event.which == 40) {        
              sibling = parent.next('div.rSelectOption:visible').children('input')
              if((sibling.length == 0) && (parent.is('.rSelectBoxOptionGroup'))) {
                sibling = parent.parent().next('.rSelectBoxOptionGroup').children('input');
              }
            } else {
              sibling = $(this).parent().prev('div.rSelectOption:visible').children('input');
            }
            if(sibling.length > 0) {
              $(this).blur();
              sibling.focus();
              event.preventDefault();
            }
          }
        });
      });
/*      var label = $('<label/>')
        .appendTo(filterbar)
        .attr('for',select.attr('id')+'-searchBox')
        .text(this.options.filter+':');
      filterbar.append(' ');*/
		  var input = $('<input>')
  		  .bind('keypress',autocompletePreventSubmit)
  		  .attr('title',this.options.filter)
        .appendTo(filterbar)
        .attr('id',select.attr('id')+'-searchBox')
        .addClass('rSelectBox-searchBox')
        .addClass('rEditBox')
                        
        .bind('keyup', function(event) {
          event.preventDefault();

          if(event.which == 27) {
            $(this).parent().children('a.rButton').focus().click();
            return;
          }
          if(event.which == 40) {
            $((radio ? 'div.rSelectOption' : 'option'),select).each(function() {  
              if($(this).is( ":visible" )) {
                if(radio) {            
                  select.val($('input',this).value);
                  $('input',this).focus();
                } else {
                  select.val(this.value);
                }
                return false;
              }
            });
            if(!radio) {            
              select.focus();
            }
            return;
          }
          if(input.val() == '') {
            $((radio ? 'fieldset, div.rSelectOption' : 'optgroup, option'),select).show();
          } else {
       			var matcher = new RegExp( $.ui.autocomplete.escapeRegex( input.val() ), "i" );
            $((radio ? 'fieldset' : 'optgroup'),select).each(function() {
              $(this).hide();
            });
            $((radio ? 'div.rSelectOption' : 'option'),select).each(function() {
              var opt = $(this);
              if(opt.text().match(matcher)) {
                opt.parent().show();
                opt.show()
              } else {
                opt.hide();
              }
            })
          }
          resize();
        });        
      var unfilter = $('<a href="#">X</a>')
        .appendTo(filterbar)
        .attr('title',this.options.unfilter)
        .addClass('rButton rSplitButton-right')
        .click(function(event) {
          event.preventDefault();
          input          
            .val('')
            .keyup()
            .blur();

        });
      select.height(select.height());
      function resize() {        
        wrapper.width(select.outerWidth());
        input.width(select.width()-(buttons ? buttons.outerWidth(true) : 0)-5-unfilter.outerWidth(true));
      }

      if(select.is(':visible')) {
        resize();
      }
      var coord = wrapper.offset();
      coord.top = coord.top + $(window).scrollTop();
      coord.left = coord.left + wrapper.outerWidth(true) - 2 + $(window).scrollLeft();
      if(coord.top < 0) {
        coord.top = 0;
      }
      coord.top = coord.top - 2;      
      $('#'+select.attr('id')+'-errorBox').offset(coord);
      
      input.notBlank();            
		}
	});
})( jQuery );

(function( $ ) {
	$.widget( "ui.combobox", {
		_create: function() {
			var self = this,
				select = this.element.hide();

			var input = $( "<input>" )
  		  .bind('keypress',autocompletePreventSubmit)
        .attr('id',select.attr('id')+'-extended')
				.insertAfter( select )
				.autocomplete({
					delay: 0,
					minLength: 0,
					source: (function() {
      		    var options = new Array();
              var index = 0;
              select.children("option",select).each(function() {
                if(this.value) {
                  options[index] = {value: this.text,
                    category: '',
                    label: this.text,
                    option: this}
                  index ++;
                }
              });
              select.children("optgroup",select).each(function() {
                var group = this;
                $("option",group).each(function() {              
                  options[index] = {value: this.text,
                    category: group.label,
                    label: this.text,
                    option: this}
                  index ++;
                });                
              });
              return options;
            }()),

					select: function( event, ui ) {
						ui.item.option.selected = true;
						self._trigger( "selected", event, {
							item: ui.item.option
						});
					},
					change: function( event, ui ) {
					  inp = $(this);
  					var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( inp.val() ) + "$", "i" );
  					var valid = false;
  					$( "option",select ).each(function() {
  					  this.selected = false;
  					})
            .each(function() {
  					   
  					  if($(this).text().match(matcher)) {
  					    this.selected = true;
                inp.val($(this).text());
                valid = true;
  					  }
  					});
  					if(!valid) {
  					  inp.val('');
  					}
					}
				})
				.addClass( "rSelectBox" );
			  
      function selectChanged() {
			  var text = ''; 
        if(select.val() != '') {
  				$('option',select).each(function() {
            if(this.value == select.val()) {
              text = $(this).text();
              return false;
            }
          });
        }
        input.val(text);        
      }
  		select.bind('change', selectChanged);
      selectChanged();

			input.data( "autocomplete" )._renderItem = function( ul, item ) {
				return $( "<li></li>" )
					.addClass(item.cssClass)
					.data( "item.autocomplete", item )
					.append( "<a>" + item.label + "</a>" )
					.appendTo( ul );
			};
			var id = select.attr('id');
//		  input.attr('id',id+'-input');			
//      input.attr('id',id+'-EditBox');
      $('#'+id+'-label').attr('for',id+'-extended');
      input.data( "autocomplete" )._renderMenu = function( ul, items ) {
  			var self = this,
  				currentCategory = "";
  			$.each( items, function( index, item ) {
  				if ( item.category != currentCategory ) {
  					ul.append( "<li class='ui-autocomplete-category'>" + item.category + "</li>" );
  					currentCategory = item.category;
  				}
  				self._renderItem( ul, item );
  			});
  		};
  		
			var button = $( "<a>&#9660;</a>" )
				.attr( "tabIndex", -1 )
				.attr( "href", '#' )				
				.attr( "id", select.attr('id')+'-dropDown')
				.insertAfter( input )
        .addClass( "rButton" )
        .addClass( "rSplitButton-right" )        
				.addClass( "rSelectBox" )        				
				.click(function(event) {
					// close if already visible
					if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
						input.autocomplete( "close" );
            event.preventDefault();
						return false;
					}

					// pass empty string as value to search for, displaying all results
					input.autocomplete( "search", "" );
					input.focus();
          event.preventDefault();
					return false;
				});
			if(!mobileVersion) {
        input.width(select.width()-button.outerWidth());
      }				
		}
	});
})( jQuery );

function handleMessages() {
  $('div.rMessages').stop(true,true).hide().fadeIn('slow').delay(6000).fadeOut('slow');
}
function documentReloaded() {
  $('.rInputErrorBox').unbind('click.rCloseOnClick').bind('click.rCloseOnClick',function() { $(this).hide()});

  $('form').unbind('submit.rNotBlank').bind('submit.rNotBlank', function() {
    $('input.rEmptyNotBlank',this).val('');    
  });
  $('input.rNotBlank, select.rNotBlank').notBlank();    
  $('div.rSelectBox').each(function() {
    $('label#'+this.id+'-label').unbind('click.rFocusSelectOption').bind('click.rFocusSelectOption',function(event) {
      event.preventDefault();
      $('input.rSelectOption',$('#'+$(this).attr('for'))).each(function() {
        this.focus();             
        return false;
      });
    })
  });
}
function documentReady() {
  handleMessages();
  documentReloaded();
}
jQuery.extend(jQuery.expr[':'], {
    focus: function(element) {
        return element == document.activeElement; 
    }
});
$(document).ready(documentReady);
function addHiddenKeys(obj) {
  $('.rHiddenKeys').each(function() {
    obj[this.name] = this.value;
  });
  return obj;
}