<?php
  define('CFG_ROAD_VERSION',0.5);
  $__roadExecutionStartTime = microtime(true);

  if(isset($_SERVER['WINDIR'])) {
    define('CFG_WINDOWS',true);
  } else {
    define('CFG_WINDOWS',false);  
  }
  define('CFG_LINUX',!CFG_WINDOWS);
    
  if(CFG_WINDOWS) {
    define('CFG_ROAD_DIR',str_replace('\\','/',realpath(dirname(__FILE__).'/../')));    
    define('CFG_ROOT_DIR',str_replace('\\','/',realpath(CFG_ROAD_DIR.'/../')));
  } else {
    define('CFG_ROAD_DIR',realpath(dirname(__FILE__).'/../'));
    define('CFG_ROOT_DIR',realpath(CFG_ROAD_DIR.'/../'));    
  }
  if(!isset($_SERVER['SCRIPT_URL'])) {
    $_SERVER['SCRIPT_URL'] = str_replace('\\','/',$_SERVER['SCRIPT_NAME']);
  }

  if(!isset($_SERVER['SCRIPT_URI'])) {
    // !TODO: respect shema and port
    $_SERVER['SCRIPT_URI'] = 'http://'.$_SERVER['HTTP_HOST'].'/'.$_SERVER['SCRIPT_URL'];
  }

  require_once(CFG_ROAD_DIR.'/core/constants.php');
  require_once(CFG_ROAD_DIR.'/core/classes.php');  
  require_once(CFG_ROAD_DIR.'/core/exceptions.php');
  require_once(CFG_ROAD_DIR.'/core/formats.php');
  require_once(CFG_ROAD_DIR.'/core/db.php');
  require_once(CFG_ROAD_DIR.'/core/controls.php');  
  require_once(CFG_ROAD_DIR.'/utils/generic.php');
  require_once(CFG_ROAD_DIR.'/utils/string.php');
  require_once(CFG_ROAD_DIR.'/utils/system.php');
  require_once(CFG_ROAD_DIR.'/utils/compatibility.php');
  require_once(CFG_ROAD_DIR.'/drivers/mysqli.php');  

  $__dummy = $_SERVER['SCRIPT_URL'];
  if(CFG_WINDOWS) {
    $__dummy = str_replace('\\','/',$__dummy);
  }
  if(endsStr('/',$__dummy)) {
    $__dummy = substr($__dummy,0,-1);
  } else {
    $__dummy = filePath($__dummy);
  }
  if($__dummy == '/') {
    $__dummy = '';
  }

  define('CFG_WEB_ROOT',
    substr(
      filePath(CFG_ROAD_DIR),
      strlen(filePath($_SERVER['SCRIPT_FILENAME'])) - strlen($__dummy)
    )
  ); 

  define('CFG_SCRIPT_URL',
    substr(
      $_SERVER['SCRIPT_FILENAME'],
      strlen(filePath(CFG_ROAD_DIR))
    )
  );

  $__dummy = parse_url($_SERVER['SCRIPT_URI']);
  define('CFG_SCHEME',$__dummy['scheme']);
  define('CFG_HOST',$__dummy['host']);
  define('CFG_SITE',CFG_SCHEME.'://'.CFG_HOST);
  unset($__dummy);

  require(CFG_ROAD_DIR.'/config.php');

  error_reporting(CFG_ERROR_REPORTING);
  roadErrorReporting(CFG_ERROR_REPORTING);  
  
  if(defined('CFG_ERROR_LOG') && CFG_ERROR_LOG) {
    EException::$log = new TFileLog(CFG_ERROR_LOG);
  }

  /** @var string[] all request headers in an associative array */  
  $_REQUEST_HEADERS = getallheaders();

  if(isset($_REQUEST_HEADERS['Accept-Charset'])) {  
    /** @var float[] accepted charsets and their quality values */  
    $_ACCEPT_CHARSET = parseAcceptHeader($_REQUEST_HEADERS['Accept-Charset']);
  } else {
    $_ACCEPT_CHARSET = array();
  }
  if(isset($_REQUEST_HEADERS['Accept-Encoding'])) {
    /** @var float[] accepted content encodings and their quality values */
    $_ACCEPT_ENCODING = parseAcceptHeader($_REQUEST_HEADERS['Accept-Encoding']);
  } else {
    $_ACCEPT_ENCODING = array();
  }
  if(isset($_REQUEST_HEADERS['Accept'])) {
    /** @var float[] accepted content types and their quality values */
    $_ACCEPT_CONTENT_TYPE = parseAcceptHeader($_REQUEST_HEADERS['Accept']);
  } else {
    $_ACCEPT_CONTENT_TYPE = array();
  }
    
  $__language = CFG_DEFAULT_LANGUAGE;
  if(isset($_REQUEST_HEADERS['Accept-Language'])) {
    $__language = explode(',',$_REQUEST_HEADERS['Accept-Language']);
    $__language = explode('-',trim($__language[0]));
    $__language = trim($__language[0]);
    if(!file_exists(CFG_ROAD_DIR.'/lang/'.trim($__language).'.php')) {
      $__language = CFG_DEFAULT_LANGUAGE;
    }
  }

  if(!file_exists(CFG_ROAD_DIR.'/lang/'.$__language.'.php')) {
    throw new EException('Language file for "'.$__language.'"not found.');
  }
  define('CFG_LANGUAGE',$__language);  
  require_once(CFG_ROAD_DIR.'/lang/'.$__language.'.php');    
  unset($__language);
                                                             
  define('CFG_UTF8',('utf-8' == CFG_ENCODING));
  define('CFG_ANSI',!CFG_UTF8);
  date_default_timezone_set(CFG_TIMEZONE);
  
  
  $road = new TRoad();
  $road->executionStartTime = $__roadExecutionStartTime;

  /** @var TXHTMLOutput */
  $output = &$road->output;  
  unset($__roadExecutionStartTime);
  
  /* creating default page */
  $__roadDefaultPageClass = CFG_DEFAULT_PAGE_CLASS;  
  $road->page = new $__roadDefaultPageClass($road);
  /** @var TPage */
  $page = &$road->page;

  if(!setlocale(LC_ALL,CFG_LOCALE)) {
    triggerError(E_INVALID_LOCALE_IDENTIFIER,array(CFG_LOCALE),E_USER_WARNING);
  }
  $road->useLibrary('jquery');
  $road->useLibrary('ui');
  
?>