<?php
  global $__roadXhtmlTags; 
  $__roadXhtmlTags = array(
    'a' => TAG_DT_STF | TAG_INLINE,
    'abbr' => TAG_DT_STF | TAG_INLINE,
    'acronym' => TAG_DT_STF | TAG_INLINE,
    'address' => TAG_DT_STF,
    'applet' => TAG_DT_TF,
    'area' => TAG_SHORT | TAG_DT_STF,
    'b' => TAG_DT_STF | TAG_INLINE,
    'base' => TAG_SHORT | TAG_DT_STF,
    'basefont' => TAG_SHORT | TAG_DT_TF | TAG_INLINE,
    'bdo' => TAG_DT_STF | TAG_INLINE,
    'big' => TAG_DT_STF | TAG_INLINE,
    'blockquote' => TAG_DT_STF,
    'body' => TAG_DT_STF,
    'br' => TAG_SHORT | TAG_DT_STF | TAG_INLINE,
    'button' => TAG_DT_STF | TAG_INLINE | TAG_BLOCK_IN_INLINE,
    'caption' => TAG_DT_STF,
    'center' => TAG_DT_TF,
    'cite' => TAG_DT_STF | TAG_INLINE,
    'code' => TAG_DT_STF | TAG_INLINE,
    'col' => TAG_SHORT | TAG_DT_STF,
    'colgroup' => TAG_DT_STF,
    'dd' => TAG_DT_STF,
    'del' => TAG_DT_STF,
    'dfn' => TAG_DT_STF | TAG_INLINE,
    'dir' => TAG_DT_TF,
    'div' => TAG_DT_STF,
    'dl' => TAG_DT_STF,
    'dt' => TAG_DT_STF,
    'em' => TAG_DT_STF | TAG_INLINE,
    'fieldset' => TAG_DT_STF,
    'font' => TAG_DT_TF | TAG_INLINE,
    'form' => TAG_DT_STF,
    'frame' => TAG_SHORT | DOCTYPE_FRAMESET,
    'frameset' => DOCTYPE_FRAMESET,
    'h1' => TAG_DT_STF,
    'h2' => TAG_DT_STF,
    'h3' => TAG_DT_STF,
    'h4' => TAG_DT_STF,
    'h5' => TAG_DT_STF,
    'h6' => TAG_DT_STF,                    
    'head' => TAG_DT_STF,
    'hr' => TAG_SHORT | TAG_DT_STF,
    'html' => TAG_DT_STF,
    'i' => TAG_DT_STF | TAG_INLINE,
    'iframe' => TAG_DT_TF,
    'img' => TAG_SHORT | TAG_DT_STF | TAG_INLINE,
    'input' => TAG_SHORT | TAG_DT_STF | TAG_INLINE,
    'ins' => TAG_DT_STF,
    'isindex' => TAG_DT_TF,
    'kbd' => TAG_DT_STF | TAG_INLINE,
    'label' => TAG_DT_STF | TAG_INLINE,
    'legend' => TAG_DT_STF,
    'li' => TAG_DT_STF,
    'link' => TAG_SHORT | TAG_DT_STF,
    'map' => TAG_DT_STF,
    'menu' => TAG_DT_TF,
    'meta' => TAG_SHORT | TAG_DT_STF,
    'noframes' => TAG_DT_TF,
    'noscript' => TAG_DT_STF,
    'object' => TAG_DT_STF,
    'ol' => TAG_DT_STF,
    'optgroup' => TAG_DT_STF | TAG_BLOCK_IN_INLINE,
    'option' => TAG_DT_STF | TAG_BLOCK_IN_INLINE,
    'p' => TAG_DT_STF,
    'param' => TAG_SHORT | TAG_DT_STF,
    'pre' => TAG_DT_STF,
    'q' => TAG_DT_STF | TAG_INLINE,
    's' => TAG_DT_TF | TAG_INLINE,
    'samp' => TAG_DT_STF | TAG_INLINE,
    'script' => TAG_DT_STF,
    'select' => TAG_DT_STF | TAG_INLINE,
    'small' => TAG_DT_STF | TAG_INLINE,
    'span' => TAG_DT_STF | TAG_INLINE,
    'strike' => TAG_DT_TF | TAG_INLINE,
    'strong' => TAG_DT_STF | TAG_INLINE,
    'style' => TAG_DT_STF,
    'sub' => TAG_DT_STF | TAG_INLINE,
    'sup' => TAG_DT_STF | TAG_INLINE,
    'table' => TAG_DT_STF,
    'tbody' => TAG_DT_STF,
    'td' => TAG_DT_STF,
    'textarea' => TAG_DT_STF | TAG_INLINE,
    'tfoot' => TAG_DT_STF,
    'th' => TAG_DT_STF,
    'thead' => TAG_DT_STF,
    'title' => TAG_DT_STF,
    'tr' => TAG_DT_STF,
    'tt' => TAG_DT_STF | TAG_INLINE,
    'u' => TAG_DT_TF | TAG_INLINE,
    'ul' => TAG_DT_STF,
    'var' => TAG_DT_STF | TAG_INLINE,
    'xmp' => TAG_DT_STF    
  );

  /**
  *
  */
  class TXhtmlOutput extends TCustomOutput {    
    /** @var int Doctype of the document */
    public $doctype = DOCTYPE_STRICT;
    private $newLine = true;
    /** @var int Text indent */
    public $indent = 0;
    private $openTags = array();
    private $openRows = array();
    public $supportedContentTypes = array('text/html','application/xhtml+xml');
    public function renderError($errno, $errstr, $errfile = '', $errline = 0, $errcontext = array()) {
      if($this->road->isAjaxed()) return false;
    }

    public function renderException($exception) {
      if($this->road->isAjaxed()) return false;
    }    
    public function ajaxRedirect($url)  {
      $this->rJQuery('$(location).attr("href","'.$url.'");');
      return true;
    }
    /**
    * Render javascript
    *
    * @return void
    */
    public function rJavaScript($script, $minimalize = true)  {
      if($minimalize) {
        $script = preg_replace('/[ \n\t\r]+/',' ',$script);
      }
      $this->rTagCode('script',
/*        '<![cdata[
'.$script.'
 ]]>',*/
        $script,
        array('type'=>'text/javascript')
      );
    }    
    /**
    * Render javascript in a jQuery way
    *
    * @return void
    */
    public function rJQuery($script, $minimalize = true)  {
      $this->rJavaScript('$(function() {'.$script.'});');
    }
    /**
    * Render javascript in a jQuery way in context of a component
    *
    * @return void
    */
    public function rComponentJQuery($component, $script, $minimalize = true)  {
      $this->rJQuery('$("#'.$component->getId().'").each(function() {'.$script.'});',$minimalize);
    }    
    /**
    * Render all messages
    *
    * @return void
    */
    public function renderMessages($javaScriptRasing = false)  {

      if($javaScriptRasing && !$this->road->hasMessages(MSG_ERROR | MSG_HIGHLIGHT | MSG_SUCCESS)) {
        return;
      }
      if($javaScriptRasing && $this->road->browser->supportsJavaScript()) {
        $scripts = array();

        $msgs = $this->road->dequeueMessages(MSG_SUCCESS);
        foreach($msgs as $msg) {
          $scripts[] = 'showMessage("'.$this->escapeJSText($msg).'","Success")';
        }
        $msgs = $this->road->dequeueMessages(MSG_ERROR);
        foreach($msgs as $msg) {
          $scripts[] = 'showMessage("'.$this->escapeJSText($msg).'","Error")';
        }
        $msgs = $this->road->dequeueMessages(MSG_HIGHLIGHT);
        foreach($msgs as $msg) {
          $scripts[] = 'showMessage("'.$this->escapeJSText($msg).'","Highlight")';
        }
        if(count($scripts) > 0) {
          $this->rJQuery(implode("\n",$scripts),false);
        }
      } else {
        
        $attributes = array(
          'class' => 'rMessages'
        );
        if(!$javaScriptRasing) {
          $attributes['id'] = 'rMainRoadMessages';
        }
        if($this->road->browser->supportsJavaScript()) {
          $attributes['style'] = 'display: none'; 
        }
              
        $this->rTagOpen('div',$attributes);
        $msgs = $this->road->dequeueMessages(MSG_SUCCESS);
        foreach($msgs as $msg) {
          $this->rTagText('div',$msg,array('class' => 'rMessageSuccess'));
        }    
        $msgs = $this->road->dequeueMessages(MSG_ERROR);
        foreach($msgs as $msg) {
          $this->rTagText('div',$msg,array('class' => 'rMessageError'));
        }
        $msgs = $this->road->dequeueMessages(MSG_HIGHLIGHT);          
        foreach($msgs as $msg) {
          $this->rTagText('div',$msg,array('class' => 'rMessageHighlight'));
        }
        $this->rTagClose('div');
      }
    }
    public function __construct($road) {
      if(CFG_ALLOW_XHTML_CONTENT_TYPE) {
        $xh = contentTypeAccepted('application/xhtml+xml');
        if($xh && ($xh >= contentTypeAccepted('text/html'))) {
          $this->contentType = 'application/xhtml+xml';        
        } else {
          $this->contentType = 'text/html';
        }        
      } else {
        $this->contentType = 'text/html';      
      }      
      parent::__construct($road);      
    }
    /**
    * Renders the input error box for suplied control
    *
    * @return void
    */
    public function rInputErrorBox(TControl $control)  {
      if(CFG_INPUT_ERROR_REPORTING & INPUT_ERROR_INLINE) {
        if(!$control->isErrorneous()) {
          if($this->road->browser->supportsJavascript()) {
            $attributes['style'] = 'display: none;';
          } else {
            return;
          }
        }
        $attributes['class'] = 'rInputErrorBox';
        $attributes['id'] = $control->getId().'-errorBox';
        $tag = 'div';
/*        if($this->road->browser->supportsCss()) {
          $tag = 'div';
        } else {
          $tag = 'span';        
        }*/
        if(!$control->isErrorneous()) {
          $attributes['style'] = 'display: none;';
        } 
        $this->rTagText($tag,$control->getErrorMessage(),$attributes);
      }
    }



    /**
    * Find element info in XHTML element reference
    *
    * @param string Element name
    * @return int Element type
    */
    public function getTagType($tagName, $validityControl = CFG_VALIDITY_CONTROL)  {
      if(!(CFG_VALIDITY_CONTROL || CFG_READABLE_OUTPUT)) {
        return TAG_INLINE | TAG_DT_STF;
      }
      global $__roadXhtmlTags;
      if(!isset($__roadXhtmlTags[$tagName])) {
        if($validityControl) {
          triggerError(E_USE_OF_UNKNOWN_ELEMENT,array($tagName), E_USER_WARNING);
        }
        return 0;
      }      
      $res = $__roadXhtmlTags[$tagName];
      if($validityControl) {
        if(!($this->doctype & $res)) {
          triggerError(E_DOCTYPE_DOES_NOT_ALLOW_THIS_ELEMENT,array($tagName), E_USER_WARNING);
        }
        if(!($res & TAG_INLINE) && !($res & TAG_BLOCK_IN_INLINE)) {
          $last = end($this->openTags);
          if(isset($__roadXhtmlTags[$last])) {
            $lastType = $__roadXhtmlTags[$last];
            if(!($lastType & TAG_BLOCK_IN_INLINE) && ($lastType & TAG_INLINE)) {
              triggerError(E_INLINE_ELEMENT_CANNOT_CONTAIN_BLOCK_ELEMENTS,array($last,$tagName), E_USER_WARNING);          
            }
          }
        }
      }
      return $res;    
    }
    /**
    * Clear buffered output
    *
    * @return void
    */
    public function clearBuffer ( )  {
      $this->buffer = '';
    }
    /**
    * Returns buffered output
    *
    * @return string
    */
    public function getBuffer ( )  {
      return $this->buffer;
    }
    /**
    * Render code
    * 
    * @param string code
    * @return void
    */
    public function rCode($code, $indented = false, $line = false)  {
      if(!CFG_READABLE_OUTPUT) {      
        if($line) {
          $line = false;
          $code .= ' ';
        }
        if($line) {
          $indented = false;
          $code = ' '.$code;
        }
      }
      if($indented) {
        $code = str_pad('',$this->indent,' ').$code;
      }
      if(CFG_READABLE_OUTPUT && $indented && !$this->newLine) {
        $code = "\n".$code;
      }      
      if($line) {
        $code .= "\n";
      }
      $this->write($code);
      if(CFG_READABLE_OUTPUT) {
        $l = strlen($code);
        $this->newLine = (($l > 0) && (substr($code,$l-1,1) == "\n"));
      }
    }

    /**
    * Render code to a line
    * 
    * @param string code
    * @param bool indent the code    
    * @return void
    */
    public function rLine($code, $indented = false)  {
      $this->rCode($code,$indented,true);
    }
    public function escapeJSText($text)  {
      return str_replace(array('"', '/', "'"),array('\"','\/',"\'"),$text);
    }
    /**
    *
    *
    * @return void
    */
    public function escapeText($text)  {
      $code = str_replace('  ',' &nbsp;',htmlspecialchars($text));
      if(substr($text,0,1) == ' ') {
        $code = substr_replace($code,'&nbsp;',0,1);
      }
      $len = strlen($text);
      if(substr($text,-1,1) == ' ') {
        $code = substr_replace($code,'&nbsp;',-1,1);
      }      
      return $code;
    }
    /**
    * Renders htmlencoded text
    *
    * @param string Text
    * @return void
    */
    public function rText ($text, $indented = false, $line = false)  { 
      $this->rCode($this->escapeText($text), $indented, $line);
    }
    private function handleIndentAndLine(&$indented,&$line,$tagType) {
      if(!CFG_READABLE_OUTPUT) {
        $indented = false;
        $line = false;        
      } elseif($tagType & TAG_INLINE) {
        if($indented === null) $indented = $this->newLine;
        if($line === null) $line = false;        
      } else {
        if($indented === null) $indented = true;
        if($line === null) $line = true;
      }
    }
    private function getTagCode($tagName, $attributes = null, $closed)  {
      $code = '<'.$tagName;
      if($attributes) {
        if(is_array($attributes)) {
          foreach($attributes as $name => $value) {
            if($value === false) {
              continue;
            }          
            if($value === true) {
              $value = $name;
            }
            $code .= ' '.$name.'="'.htmlspecialchars($value).'"';
          }
        } else {
          $code .= ' '.$attributes;
        }
      }
      if($closed) {
        $code .= ' /';
      }
      $code .= '>';
      return $code;
    }
    /**
    * Render HTML start tag
    *
    * @param string Tag name
    * @param string[] Attribute list
    * @param bool indent the code
    * @param bool put the code on single line                
    * @return void
    */
    public function rTagOpen($tagName, $attributes = null, $indented = null, $line = null)  {
      $tt = $this->getTagType($tagName);
      if(CFG_VALIDITY_CONTROL && ($tt & TAG_SHORT)) {
        triggerError(E_ELEMENT_SHOULD_BE_SHORT,array($tagName),E_USER_WARNING);
      }
      $intendedIndented = $indented; 

      $this->openTags[] = $tagName;
      $this->handleIndentAndLine($indented,$line,$tt);
      if(!($tt & TAG_INLINE)) {
        $intendedIndented = $indented;
      }

      $code = $this->getTagCode($tagName,$attributes,false);

      $this->rCode($code,$indented,$line);
      if($intendedIndented) {
        $this->indent ++;
      }      
    }
    
    /**
    * Render a short HTML tag
    *
    * @param string Tag name
    * @param string[] Attribute list
    * @param bool indent the code
    * @param bool put the code on single line                
    * @return void
    */
    public function rTagShort($tagName, $attributes = null, $indented = null, $line = null)  {
      $tt = $this->getTagType($tagName);
      $this->handleIndentAndLine($indented,$line,$tt);

      $code = $this->getTagCode($tagName,$attributes,true);

      $this->rCode($code,$indented,$line);   
    }    

    /**
    * Render ending HTML tag
    *
    * @param string Tag name
    * @param bool indent the code
    * @param bool put the code on single line
    * @return void
    */
    public function rTagClose($tagName, $indented = null, $line = null)  {
      if(CFG_VALIDITY_CONTROL) {
        $lastTag = array_pop($this->openTags);
        if($tagName !== $lastTag) {
          triggerError(E_CLOSING_TAG_OMMITED,array($tagName,$lastTag),E_USER_WARNING);
        }
      }
      
      $tt = $this->getTagType($tagName,false);
      $this->handleIndentAndLine($indented,$line,$tt);

      $code = '</'.$tagName.'>';
      if($indented) {
        $this->indent --;
      }
      $this->rCode($code,$indented,$line);
    }
    /**
    * Render link to ROAD homepage
    *
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rRunningOnTheRoad($indented = null, $line = null)  {
      $this->rLinkStart('http://road.goce.cz/',array(
        'class'=>'rRunningOnTheRoad',
        'title'=>'Go to ROAD homepage'
      ));
      $this->rImg('/road/road-smallest.png','I\'m running on the ROAD');
      $this->rTagClose('a');
    }
    /**
    * Render a tag
    *
    * @param string Destination URI
    * @param mixed Title or attributes
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rLinkStart($uri, $attributes = array(), $indented = null, $line = null)  {

      if(!is_array($attributes) && ($attributes !== null)) {
        $attributes = array('title'=>$attributes); 
      }
      if(!startsStr('#',$uri)) {
        $uri = absoluteUri($uri, CFG_ABSOLUTE_SITE_URI);
      }
      $attributes['href'] = $uri;
      $this->rTagOpen('a',$attributes,$indented,$line);
    }
    /**
    * Render a link tag
    *
    * @param string Destination URI
    * @param mixed Title or attributes
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rLinkText($uri, $text, $attributes = array(), $indented = null, $line = null)  {
      $this->rLinkCode($uri, $text, $attributes, $indented, $line);
    }
    /**
    * Render a link tag
    *
    * @param string Destination URI
    * @param mixed Title or attributes
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rLinkCode($uri, $text, $attributes = array(), $indented = null, $line = null)  {

      if(!is_array($attributes) && ($attributes !== null)) {
        $attributes = array('title'=>$attributes); 
      }
      if(!startsStr('#',$uri)) {
        $uri = absoluteUri($uri, CFG_ABSOLUTE_SITE_URI);
      }
      $attributes['href'] = $uri;
      $this->rTagCode('a',$text,$attributes,$indented,$line);
    }
    /**
    * Render img tag
    *
    * @param string Source file
    * @param int Width
    * @param int Height
    * @param string Title/Alt            
    * @param string[] Attribute list
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rImg($sourceFile, $widthOrTitle = null, $height = null, $title = null, $attributes = null, $indented = true, $line = true)  {
      $args = array(
        'src' => absoluteUri($sourceFile, CFG_ABSOLUTE_SITE_URI)
      );
      if($widthOrTitle !== null) {
        if(is_int($widthOrTitle)) {
          $args['width'] = $widthOrTitle;
        } else {
          $title = $widthOrTitle;
        }
      }
      if(is_array($height)) {
        $attributes = $height;
        $height = null;
      }      
      if($height !== null) {
        $args['height'] = $height;
      }
      if($title === null) {
        $args['alt'] = basename($sourceFile);
      } else {
        $args['title'] = $title;
        $args['alt'] = $title;        
      }
      if($attributes !== null) {
        $args = array_merge($args,$attributes);
      }
      $this->rTagShort('img',$args,$indented,$line);
    }

    /**
    * Render tag and its content
    *
    * @param string Tag name
    * @param string Tag content    
    * @param string[] Attribute list
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rTagText($tagName, $text, $attributes = null, $indented = null, $line = null)  {
      $this->rTagCode($tagName,$this->escapeText($text),$attributes,$indented,$line);
    }
    
    /**
    * Render tag and its content
    *
    * @param string Tag name
    * @param string Tag content    
    * @param string[] Attribute list
    * @param bool indent the code
    * @param bool put the code on single line        
    * @return void
    */
    public function rTagCode($tagName, $code, $attributes = null, $indented = true, $line = true)  {
      $tt = $this->getTagType($tagName);
      if(CFG_VALIDITY_CONTROL && ($tt & TAG_SHORT)) {
        triggerError(E_ELEMENT_SHOULD_BE_SHORT,array($tagName),E_USER_WARNING);
      }
      $this->handleIndentAndLine($indented,$line,$tt);

      $code = $this->getTagCode($tagName,$attributes,false).$code.'</'.$tagName.'>';
      $this->rCode($code,$indented,$line);
    }
    public function warningReported($warning, $warningCount)  {
      $this->rTagText('a','* '.$warningCount,array('title' => $warning[1], 'href' =>'#', 'class' => 'rWarningOccurence'.($warning[0] == E_NOTICE ? ' rNoticeOccurence' : ''),'id' => 'rWarningOccurence'.$warningCount, 'onclick' => 'document.getElementById(\'rWarnings\').style.display = \'block\'; x = document.getElementById(\'rWarningContent'.$warningCount.'\'); if(x.style.display == \'block\') { x.style.display = \'none\' } else { x.style.display = \'block\' } return false;'),false,false);
    }    
    public function renderWarnings($warnings)  {

      $this->rTagOpen('div',array('id' => 'rWarnings'));
      $this->rTagOpen('div',array('class' => 'rWarningsTitle'));
      $this->rCode('<a title="Close this window" href="#" onclick="document.getElementById(\'rWarnings\').style.display = \'none\'">X</a><span>Warnings &amp; notices</span>',true);
      $this->rTagClose('div');
      $this->rTagOpen('ol');
      $i = 0;
      foreach($warnings as $warning) {
        $i ++;

        $this->rTagOpen('li',array('class' => ($warning[0] == E_NOTICE ? 'rNotice' : 'rWarning')));

        $this->rLinkStart('#',array('onclick' => 'x = document.getElementById(\'rWarningContent'.$i.'\'); if(x.style.display == \'block\') { x.style.display = \'none\' } else { x.style.display = \'block\' } return false;'));
        $this->rCode(strip_tags($warning[1],'b|strong|i|em') );
        $this->rTagClose('a');
        $this->rTagOpen('div',array('id' => 'rWarningContent'.$i, 'style' => 'display: none'));
        $this->rCode('<span>on line <strong>'.$warning[3].'</strong></span> on <strong>'.htmlspecialchars($warning[2]).'</strong>',true);
        $this->rTagClose('div');
        $this->rTagClose('li');        
      }
      $this->rTagClose('ol');
      $this->rTagClose('div');
    }    
  }


  abstract class TCustomXhtmlRenderer extends TCustomRenderer {
    /** @var TXhtmlOutput */
    public $output;


    /**
    * Appends unit code if needed
    *
    * @param mixed Value
    * @param string Default unit
    * @return string
    */
    public function checkUnits($value, $default = 'px')  {
      if(is_numeric($value)) {
        $value .= $default;
      }
      return $value;
    }

    /**
    * Renders label for a control
    *
    * @param TControl
    * @return void
    */
    public function renderLabel($control, $colon = true)  {
      $attributes = $this->getAttributes($control,
        ATTRIBUTE_CLASS | ATTRIBUTE_ERROR | ATTRIBUTE_VISIBLE | ATTRIBUTE_TITLE
      );
      $attributes['class'] .= ' rLabel';
      $attributes['for'] = $control->getId();
      $attributes['id'] = $control->getId().'-label';      
      $this->output->rTagCode('label',$this->output->escapeText($control->getCaption()).($colon ? ': ' : ''),$attributes);
    }
    protected function getWidth($control) {
      if($control->width === null) {
        return false;
      } else {
        return $this->checkUnits($control->width);
      }
    }
    protected function getHeight($control) {
      if($control->height === null) {
        return false;
      } else {
        return $this->checkUnits($control->height);
      }      
    }
    /**
    * Returns atributes for selected control
    *
    * @param TControl
    * @return string[]
    */
    public function getAttributes($control, $attributeMask = ATTRIBUTE_STANDARD)  {
      $attributes = array();
      $style = array();
      if(isset($control->height) && ($attributeMask & ATTRIBUTE_HEIGHT) && (($x = $this->getHeight($control)) !== false)) {      
        $style[] = 'height: '.$x;
      }
      if(isset($control->width) && ($attributeMask & ATTRIBUTE_WIDTH) &&  (($x = $this->getWidth($control)) !== false)) {
        $style[] = 'width: '.$x;
      }
      if(isset($control->cssStyle) && ($attributeMask & ATTRIBUTE_STYLE) && ($control->cssStyle !== null)) {
        $style[] = $control->cssStyle;
      }
      if(isset($control->visible) && !$control->visible && ($attributeMask & ATTRIBUTE_VISIBLE)) {
        if(!$control->isErrorneous()) {
          $style[] = 'display: none';
        }
      }
      if(count($style) > 0) {
        $attributes['style'] = implode('; ',$style);
      }
      if(method_exists($control,'getId') && ($attributeMask & ATTRIBUTE_ID)) {
        $attributes['id'] = $control->getId();
      }
      if($attributeMask & ATTRIBUTE_TITLE) {
        if(isset($control->title) && ($control->title !== null)) {
          $attributes['title'] = $control->title;
        } else {
          if(isset($control->displayCaption) && $control->isInstanceOf('TEditBox') /* && !$control->displayCaption*/) {
            $attributes['title'] = $control->getCaption();          
          }
        }
      }
      if(isset($control->enabled) && ($attributeMask & ATTRIBUTE_DISABLED) && !$control->enabled) {
        $attributes['disabled'] = 'disabled';
      }
      
      if(isset($control->readOnly) && ($attributeMask & ATTRIBUTE_READONLY) && $control->readOnly) {
        $attributes['readonly'] = 'readonly';        
      }
      if($attributeMask & ATTRIBUTE_CLASS) {
        if(isset($control->additionalCssClasses)) {
          $class = $control->additionalCssClasses;
        } else {
          $class = array();        
        }
        if($control->isInstanceOf('TSubmitButton')) {
          if($control->form && $control->form->defaultButton && ($control->form->defaultButton == $control)) {
            $class[] = 'rDefaultButton';
          }
        }
        if(isset($control->newRow) && $control->newRow && $control->parent->allowRows) {
          $class[] = 'rFirstInRow';
        }        
        if(isset($control->enabled)) {
          if($control->enabled) {
            $class[] = 'rEnabled';
          } else {
            $class[] = 'rDisabled';
          }
        }
        if(method_exists($control,'isRequired') && $control->isRequired()) {
          $class[] = 'rRequired';
        }
        if(isset($control->readOnly) && $control->readOnly) {
          $class[] = 'rReadOnly';
        }        
        if(method_exists($control,'getClass')) {
          $class[] = 'r'.strDelete($control->getClass(),0,1);
        }
        if(isset($control->cssClass) && ($control->cssClass !== null)) {
          $class[] = $control->cssClass;
        }
        if(method_exists($control,'isErrorneous') && ($attributeMask & ATTRIBUTE_ERROR) && $control->isErrorneous()) {
          $class[] = 'rInputError';
        }        
        if(count($class) > 0) {
          $attributes['class'] = implode(' ',$class);
        }
      }


      return $attributes;
    }        
    public function renderChildren(TComponent $component, $flags = null) {
      if($component->allowRows) {
        $this->output->rTagOpen('div',array('class'=>'rFormRow'));
      }
/*      foreach($component->components as $c) {
        if(isset($c->newRow)) {
          $c->newRow = false;
          break;
        }
      }*/
      parent::renderChildren($component,$flags);
      if($component->allowRows) {
        $this->output->rTagClose('div');
      }
    }
    public function renderContent(TComponent $component, $flags = null) {
      $this->renderHeader($component,$flags);      
      $this->renderChildren($component,$flags);
      $this->renderFooter($component,$flags);    
    }
    public function render(TComponent $component, $flags = null) {
//      if($this->road->dequeueMessages())
      if(isset($component->newRow) && $component->parent->allowRows) {
        if($component->newRow) {
          if($component->parent->renderFlags & RENDER_FLAG_ROW_BROKEN) {
            $this->output->rTagClose('div');
            $this->output->rTagOpen('div',array('class'=>'rFormRow'));
          }
        } else {
          $this->output->rCode(' ');
        }
        $component->parent->renderFlags = $component->parent->renderFlags | RENDER_FLAG_ROW_BROKEN;        
      }
      if($component->parent != $component->road) {
        $this->output->renderMessages(true);
        $this->road->clearMessages();
      }

      $this->renderContent($component,$flags);
      if($this->road->browser->supportsJavascript()) {
        if($component->javaScript) {      
          $this->output->rJavaScript($component->javaScript,false);
        }
        if($component->jQuery) {      
          $this->output->rJQuery('$("#'.$component->getId().'").each(function() {'.$component->jQuery.'});',false);
        }
        if(isset($component->focused) && ($component->focused)) {
          $this->output->rJQuery('$("#'.$component->getId().'")
            .delay("10")
            .queue(function() {
               $(this)
                .focus()
                .dequeue();            
            });');
        }        
        if(isset($component->refreshInterval) && ($component->refreshInterval !== null) && (($this->output->type !== OUTPUT_MOBILE) || CFG_MOBILE_AUTO_REFRESH)) {
          $this->output->rJQuery('$("#'.$component->getId().'")
            .delay('.$component->refreshInterval.')
            .queue(function() {
               $(this).refresh();
            });
          ');
        }
      }
    }
  }

  $this->output = new TXhtmlOutput($this);  
?>