<?php
  class TPHPOutput extends TCustomOutput {
//    public $contentType = 'application/json';
    public $buffered = false;
  
    public $contentType = 'text/plain';
    
    public function warningReported($warning, $warningCount)  {
      return true;
    }  

    public function renderException($exception) {
      $this->renderError($exception->getCode(),
        $exception->getMessage(),
        $exception->getFile(),
        $exception->getLine()
      );
    }
    public function rCode($code)  {
      $this->write($code);
    }
    public function rLine($code)  {
      $this->rCode($code."\n");
    }    
    public function escapeText($text) {
      return addslashes($text);
    }
    public function quoteText($text) {
      return "'".$this->escapeText($text)."'";
    }

    
  }
  class TPHPRenderer extends TCustomRenderer {
    /** @var TPHPOutput */
    public $output;    
  }
  class TPHPPage extends TPHPRenderer {
    /** @var TSelectBox */    
    public function renderHeader(TComponent $component, $flags = null) {
      $this->output->rLine("<?php
  /*
    PHP source code generated to help you adapt complex
    components to match structure of your database 
  */");          
    }
    /** @var TSelectBox */    
    public function renderFooter(TComponent $component, $flags = null) {
      $this->output->rCode("?>");          
    }    
  }
  class TPHPNotable extends TPHPRenderer {
    /** @var TComponent */    
    public function renderHeader(TComponent $component, $flags = null) {
      $this->output->rLine('
  // '.$component->getId());
    }        
  }
  class TPHPSelectBox extends TPHPNotable {
    /** @var TSelectBox */    
    public function renderChildren(TComponent $component, $flags = null) {
//      $this->output->rCode('asdas');    
    }        
  }
  class TPHPListerColumn extends TPHPNotable {
    /** @var TListerColumn */    
    public function render(TComponent $component, $flags = null) {
      if(isset($_GET['prefixed'])) {
        $name = $component->name;
      } else {
        $name = $component->field;      
      }
      $this->output->rLine('
  $'.$name.' = new '.$component->getClass().'($'.$component->parent->name.','.$this->output->quoteText($name).');
  $'.$name.'->field = '.$this->output->quoteText($component->field).';
  $'.$name.'->caption = '.$this->output->quoteText($component->getCaption()).';');
      if($component->format) {
        $this->output->rLine('  $'.$name.'->format = new '.$component->format->getClass().'($'.$name.');');
      }
    }        
  }  
  $this->output = new TPHPOutput($this);

  $this->output->type = OUTPUT_XML;  
  $this->output->registerRenderer(new TPHPPage($this),'TPage');
  $this->output->registerRenderer(new TPHPRenderer($this),'TComponent');
  $this->output->registerRenderer(new TPHPSelectBox($this),'TSelectBox');
  $this->output->registerRenderer(new TPHPNotable($this),'TLister');  
  $this->output->registerRenderer(new TPHPListerColumn($this),'TListerColumn');
      
?>